#pragma once

// CDropEntranceWnd

#include "ODT.h"

class CDropEntranceWnd : public CWnd, public CDropTargetWnd
{
	DECLARE_DYNAMIC(CDropEntranceWnd)

protected:
	COLORREF m_rgb;
	CString m_strText;
	DWORD_PTR m_dw1;

public:
	CDropEntranceWnd();
	virtual ~CDropEntranceWnd();

	BOOL Create(CWnd* pWndParent, UINT nID, COLORREF rgb, const CString& strText, DWORD_PTR dw1);

	CFont m_font;
	CODT m_odt;

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();

	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual DROPEFFECT OnDragScroll(DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject,	DROPEFFECT dropEffect, CPoint point);

};


