
// LeftView.cpp : CLeftView NX̎
//

#include "stdafx.h"
#include "ClipMM.h"

#include "ClipMMDoc.h"
#include "LeftView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CTreeView)

BEGIN_MESSAGE_MAP(CLeftView, CTreeView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, &CLeftView::OnTvnSelchanged)
	ON_WM_CREATE()
END_MESSAGE_MAP()


// CLeftView RXgNV/fXgNV

CLeftView::CLeftView()
{
	// TODO: \zR[hɒǉ܂B
}

CLeftView::~CLeftView()
{
}

BOOL CLeftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: CREATESTRUCT cs ύXāAWindow NX܂̓X^CύX܂B

	return CTreeView::PreCreateWindow(cs);
}

void CLeftView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

}


// CLeftView ff

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CClipMMDoc* CLeftView::GetDocument() // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CClipMMDoc)));
	return (CClipMMDoc*)m_pDocument;
}
#endif //_DEBUG


// CLeftView bZ[W nh[


void CLeftView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	CClipMMDoc* pDoc = GetDocument();


	CTreeCtrl& tr = GetTreeCtrl();


	if (lHint & CClipMMDoc::updatehintReset)
	{
		// c[蒼
		tr.DeleteAllItems();

		if (pDoc->m_pArray)
		{
			// c[̃[g
			HTREEITEM hRoot = tr.InsertItem(pDoc->m_strSrc);
			tr.SetItemImage(hRoot, CCBData::icontypeFolder, CCBData::icontypeFolder);

			// qǂZbgĂ
			SetTreeSub(tr, hRoot, pDoc->m_pArray.get());
			tr.Expand(hRoot, TVE_EXPAND);
		}
	}
	if (lHint & CClipMMDoc::updatehintSelChild)
	{
		HTREEITEM hRoot = tr.GetRootItem();
		if (hRoot)
		{
			HTREEITEM hItemChild = tr.GetChildItem(hRoot);
			if (hItemChild)
			{
				tr.Select(hItemChild, TVGN_CARET);
				CCBData* pData = (CCBData*)tr.GetItemData(hItemChild);
				pDoc->UpdateAllViews(this, CClipMMDoc::updatehintSel, pData);
			}
		}
	}

}

void CLeftView::SetTreeSub(CTreeCtrl& tr, HTREEITEM hParent, CCBDataArray* pArray)
{
	for (int i = 0; i < (int)pArray->size(); i++)
	{
		shared_ptr<CCBData> pData = pArray->at(i);
		HTREEITEM hItem = tr.InsertItem(pData->GetTitle(), hParent);
		tr.SetItemData(hItem, (DWORD_PTR)pData.get());
		tr.SetItemImage(hItem, pData->m_nIconType, pData->m_nIconType);

		if (pData->m_pArrayChildren)
		{
			SetTreeSub(tr, hItem, pData->m_pArrayChildren.get());
//			tr.Expand(hItem, TVE_EXPAND);
		}
	}
}

void CLeftView::OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult)
{
	CClipMMDoc* pDoc = GetDocument();


	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	CCBData* pData = (CCBData*)pNMTreeView->itemNew.lParam;
	
	pDoc->UpdateAllViews(this, CClipMMDoc::updatehintSel, pData);


	*pResult = 0;
}


int CLeftView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();

	if (CTreeView::OnCreate(lpCreateStruct) == -1)
		return -1;

	static const UINT ids[] = {IDI_ICON_FOLDER, IDI_ICON_FILE, IDI_ICON_GDI, IDI_ICON_UNKNOWN};

	m_il.Create(16, 16, ILC_COLOR24 | ILC_MASK, 0, 4);
	for (int i = 0; i < _countof(ids); i++)
	{
		m_il.Add(pApp->LoadIcon(ids[i]));
	}

	CTreeCtrl& tr = GetTreeCtrl();
	tr.ModifyStyle(0, TVS_HASBUTTONS | TVS_LINESATROOT | TVS_HASLINES | TVS_SHOWSELALWAYS);
	tr.SetImageList(&m_il, TVSIL_NORMAL);

	return 0;
}
