// NoSelEdit.cpp : t@C
//

#include "stdafx.h"
#include "NoSelEdit.h"


// CNoSelEdit

IMPLEMENT_DYNAMIC(CNoSelEdit, CEdit)
CNoSelEdit::CNoSelEdit()
{
}

CNoSelEdit::~CNoSelEdit()
{
}


BEGIN_MESSAGE_MAP(CNoSelEdit, CEdit)
	ON_WM_GETDLGCODE()
END_MESSAGE_MAP()



// CNoSelEdit bZ[W nh


UINT CNoSelEdit::OnGetDlgCode()
{
	UINT n = CEdit::OnGetDlgCode();
	n &= ~DLGC_HASSETSEL;
	return n;
}


BOOL CNoSelEdit::PreTranslateMessage(MSG* pMsg)
{
	if (::GetFocus() == m_hWnd &&
		pMsg->message == WM_KEYDOWN &&
		pMsg->wParam == L'A' &&
		GetKeyState(VK_CONTROL) < 0)
	{
		SetSel(0, -1);
		return TRUE;
	}

	return CEdit::PreTranslateMessage(pMsg);
}
