// ODT.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "ODT.h"


// CODT


CODT::CODT()
	: m_pWnd(NULL)
	, m_pOdt(NULL)
{
}

CODT::~CODT()
{
}

BOOL CODT::Register(CDropTargetWnd* pOdt, CWnd* pWnd)
{
	m_pOdt = pOdt;
	return COleDropTarget::Register(pWnd);
}


BEGIN_MESSAGE_MAP(CODT, COleDropTarget)
END_MESSAGE_MAP()



// CODT bZ[W nh[


DROPEFFECT CODT::OnDragEnter(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	if (m_pOdt)
		return m_pOdt->OnDragEnter(pDataObject, dwKeyState, point);

	return DROPEFFECT_NONE;
}


void CODT::OnDragLeave(CWnd* pWnd)
{
	if (m_pOdt)
		m_pOdt->OnDragLeave();

}


DROPEFFECT CODT::OnDragOver(CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{
	if (m_pOdt)
		return m_pOdt->OnDragOver(pDataObject, dwKeyState, point);

	return DROPEFFECT_NONE;
}


DROPEFFECT CODT::OnDragScroll(CWnd* pWnd, DWORD dwKeyState, CPoint point)
{
	if (m_pOdt)
		return m_pOdt->OnDragScroll(dwKeyState, point);

	return DROPEFFECT_NONE;
}


BOOL CODT::OnDrop(CWnd* pWnd, COleDataObject* pDataObject,	DROPEFFECT dropEffect, CPoint point)
{
	if (m_pOdt)
		return m_pOdt->OnDrop(pDataObject, dropEffect, point);

	return DROPEFFECT_NONE;
}
