// SettingDialog.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "SettingDialog.h"
#include "afxdialogex.h"
#include "NewSelectFolder.h"

// CSettingDialog _CAO

IMPLEMENT_DYNAMIC(CSettingDialog, CDialog)

CSettingDialog::CSettingDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingDialog::IDD, pParent)
	, m_nHowToGetShellIDList(0)
{

	m_nSubDirSizeLimit = 0;
}

CSettingDialog::~CSettingDialog()
{
}

void CSettingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_SUBDIR_SIZE_LIMIT, m_nSubDirSizeLimit);
	DDX_Radio(pDX, IDC_RADIO_SHELLIDLIST, m_nHowToGetShellIDList);
	DDX_Control(pDX, IDC_EDIT_TEMPORARY_FOLDER, m_editTemporaryFolder);
}


BEGIN_MESSAGE_MAP(CSettingDialog, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_REFER_TEMPORARY_FOLDER, &CSettingDialog::OnClickedButtonReferTemporaryFolder)
END_MESSAGE_MAP()


// CSettingDialog bZ[W nh[


BOOL CSettingDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_editTemporaryFolder.SetWindowText(m_strTemporaryFolder);

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CSettingDialog::OnOK()
{
	m_editTemporaryFolder.GetWindowText(m_strTemporaryFolder);

	DWORD dw = GetFileAttributes(m_strTemporaryFolder);
	if (dw == INVALID_FILE_ATTRIBUTES ||
		!(dw & FILE_ATTRIBUTE_DIRECTORY)) 
	{
		AfxMessageBox(L"w肳ꂽtH_݂܂B");
		return;
	}

	CDialog::OnOK();
}


void CSettingDialog::OnClickedButtonReferTemporaryFolder()
{
	CString strNow;
	m_editTemporaryFolder.GetWindowText(strNow);
	CString strSelected;
	if (NewSelectFolder(m_hWnd, strNow, strSelected)) 
	{
		m_editTemporaryFolder.SetWindowText(strSelected);
	}


}
