#pragma once

#include "CBData.h"
#include "afxcmn.h"
#include "ClipMMPropertyPage.h"

// CPropertyViewDialog _CAO

class CPropertyViewDialog : public CClipMMPropertyPage
{
	DECLARE_DYNAMIC(CPropertyViewDialog)

public:
	CPropertyViewDialog();
	virtual ~CPropertyViewDialog();

	void SetData(CCBData* pData);
	void SetFormatNameArray(const CStringArray& arrayFormatNames);
	void SetStringArray(const CStringArray& arrayStr);
// _CAO f[^
	enum { IDD = IDD_PROPERTY_VIEW };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	CListCtrl m_list;
	int m_cxChar;
	afx_msg void OnRclickListProperty(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/);
	void OnListContextMenu();
	afx_msg void OnEditCopy();
	afx_msg void OnEditCopyItemTitle();
	afx_msg void OnEditCopyItemValue();
	void CopyToClipboard(BOOL bTitle, BOOL bValue);
	afx_msg void OnEditSelectAll();
	virtual void OnToolSetDefaultView();
	void SavePersistentInfo();
};
